// EncSettingDlg.h : interface of the CEncSettingDlg class
//
/////////////////////////////////////////////////////////////////////////////

#pragma once

class CEncSettingDlg : public CDialogImpl<CEncSettingDlg>, public CWinDataExchange<CEncSettingDlg>
{
public:
	enum { IDD = IDD_ENC_SETTING };

	CComboBox m_combo_name;

	CString m_batch;
	CString m_options;
	CString m_TsSplitter, m_TsSplitter_opt;
	CString m_make_gl /*, m_make_gl_opt*/;
	CString m_ts2aac, m_ts2aac_opt;
	CString m_aactool, m_aactool_opt;
	CString m_FAW /*, m_FAW_opt*/;
	CString m_CAP2ASS, m_CAP2ASS_opt;

	CButton m_check_split;
	CButton m_check_gl;
	CButton m_check_aac;
	CButton m_check_aactool;
	CButton m_check_faw;
	CButton m_check_cap2ass;

protected:
	CSettings& m_Settings;
	CSimpleArray<CSettingItem> m_SettingList;
	int m_SelectNum;
	int m_LastSelectNum;

public:
	CEncSettingDlg(CSettings& settings) : m_Settings(settings)
	{
	}

	BEGIN_DDX_MAP(CEncSettingDlg)
		DDX_CONTROL_HANDLE(IDC_SETTING_NAME, m_combo_name)

		DDX_CONTROL_HANDLE(IDC_CHECK_SPLIT, m_check_split)
		DDX_CONTROL_HANDLE(IDC_CHECK_GL, m_check_gl)
		DDX_CONTROL_HANDLE(IDC_CHECK_AAC, m_check_aac)
		DDX_CONTROL_HANDLE(IDC_CHECK_AACTOOL, m_check_aactool)
		DDX_CONTROL_HANDLE(IDC_CHECK_FAW, m_check_faw)
		DDX_CONTROL_HANDLE(IDC_CHECK_CAP2ASS, m_check_cap2ass)

		DDX_TEXT(IDC_EDIT_BATCH, m_batch)
		DDX_TEXT(IDC_EDIT_OPTIONS, m_options)
		DDX_TEXT(IDC_EDIT_SPLIT, m_TsSplitter)
		DDX_TEXT(IDC_EDIT_GL, m_make_gl)
		DDX_TEXT(IDC_EDIT_AAC, m_ts2aac)
		DDX_TEXT(IDC_EDIT_AACTOOL, m_aactool)
		DDX_TEXT(IDC_EDIT_FAW, m_FAW)
		DDX_TEXT(IDC_EDIT_CAP2ASS, m_CAP2ASS)

		DDX_TEXT(IDC_EDIT_SPLIT_OPT, m_TsSplitter_opt)
	//	DDX_TEXT(IDC_EDIT_GL_OPT, m_make_gl_opt)
		DDX_TEXT(IDC_EDIT_AAC_OPT, m_ts2aac_opt)
		DDX_TEXT(IDC_EDIT_AACTOOL_OPT, m_aactool_opt)
	//	DDX_TEXT(IDC_EDIT_FAW_OPT, m_FAW_opt)
		DDX_TEXT(IDC_EDIT_CAP2ASS_OPT, m_CAP2ASS_opt)
	END_DDX_MAP()

	BEGIN_MSG_MAP(CEncSettingDlg)
		MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_HANDLER_EX(IDC_SETTING_NAME, CBN_SELCHANGE, OnComboSelChange)
		COMMAND_ID_HANDLER_EX(IDOK, OnOK)
		COMMAND_ID_HANDLER_EX(IDCANCEL, OnCancel)
		COMMAND_ID_HANDLER_EX(IDC_SETTING_ADD, OnSettingAdd)
		COMMAND_ID_HANDLER_EX(IDC_SETTING_DEL, OnSettingDel)
		COMMAND_ID_HANDLER_EX(IDC_BUTTON_SPLIT, OnBrowse)
		COMMAND_ID_HANDLER_EX(IDC_BUTTON_GL, OnBrowse)
		COMMAND_ID_HANDLER_EX(IDC_BUTTON_AAC, OnBrowse)
		COMMAND_ID_HANDLER_EX(IDC_BUTTON_AACTOOL, OnBrowse)
		COMMAND_ID_HANDLER_EX(IDC_BUTTON_FAW, OnBrowse)
		COMMAND_ID_HANDLER_EX(IDC_BUTTON_CAP2ASS, OnBrowse)
	END_MSG_MAP()

// Handler prototypes (uncomment arguments if needed):
//	LRESULT MessageHandler(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
//	LRESULT CommandHandler(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
//	LRESULT NotifyHandler(int /*idCtrl*/, LPNMHDR /*pnmh*/, BOOL& /*bHandled*/)

	BOOL OnInitDialog(CWindow wndFocus, LPARAM lInitParam)
	{
		CenterWindow(GetParent());

		int sel = m_Settings.m_SelectNum;
		m_Settings.Load();
		m_TsSplitter = m_Settings.m_TsSplitter;
		m_make_gl = m_Settings.m_make_gl;
		m_ts2aac = m_Settings.m_ts2aac;
		m_aactool = m_Settings.m_aactool;
		m_FAW = m_Settings.m_FAW;
		m_CAP2ASS = m_Settings.m_CAP2ASS;

		m_SettingList.RemoveAll();
		int count = m_Settings.m_SettingList.GetSize();
		for (int i = 0; i < count; i++) {
			m_SettingList.Add(m_Settings.m_SettingList[i]);
		}
		m_SelectNum = m_LastSelectNum = sel + 1;

		// Rg[ݒ
		DoDataExchange(DDX_LOAD);

		m_combo_name.AddString(_T("<common>"));
		for (int i = 0; i < count; i++) {
			m_combo_name.AddString(m_SettingList[i].m_SettingName);
		}
		m_combo_name.SetCurSel(m_SelectNum);
		EnableControls();
		LoadItem();

	//	m_check_split.SetCheck(1);

		return TRUE;
	}

	LRESULT OnOK(UINT /*uNotifyCode*/, int nID, CWindow /*wndCtl*/)
	{
		SaveItem();
		m_Settings.m_TsSplitter = m_TsSplitter;
		m_Settings.m_make_gl = m_make_gl;
		m_Settings.m_ts2aac = m_ts2aac;
		m_Settings.m_aactool = m_aactool;
		m_Settings.m_FAW = m_FAW;
		m_Settings.m_CAP2ASS = m_CAP2ASS;

		m_Settings.m_SettingList.RemoveAll();
		int count = m_SettingList.GetSize();
		for (int i = 0; i < count; i++) {
			m_Settings.m_SettingList.Add(m_SettingList[i]);
		}
		m_Settings.m_SelectNum = m_LastSelectNum - 1;

		m_Settings.Save();

		m_SettingList.RemoveAll();
		EndDialog(nID);
		return 0;
	}

	LRESULT OnCancel(UINT /*uNotifyCode*/, int nID, CWindow /*wndCtl*/)
	{
		m_SettingList.RemoveAll();
		EndDialog(nID);
		return 0;
	}

	LRESULT OnSettingAdd(UINT uNotifyCode, int nID, CWindow wndCtl)
	{
		int nIndex = m_combo_name.GetCurSel();
		if (nIndex == 0) {
			return 0;
		}
		CSettingItem item;
		GetItem(item);
		if (m_combo_name.FindStringExact(0, item.m_SettingName) != CB_ERR) {
			// ݒ薼ꍇ͒ǉȂ
			return 0;
		}
		m_SettingList.Add(item);
		m_combo_name.AddString(item.m_SettingName);
		nIndex = m_combo_name.GetCount() - 1;
		m_combo_name.SetCurSel(nIndex);
		m_LastSelectNum = m_SelectNum = nIndex;
		
		return 0;
	}

	LRESULT OnSettingDel(UINT uNotifyCode, int nID, CWindow wndCtl)
	{
		int nIndex = m_combo_name.GetCurSel();
		if (nIndex <= 0) {
			return 0;
		}
		if (m_SettingList.GetSize() <= 1) {
			return 0;
		}
		m_SettingList.RemoveAt(nIndex - 1);
		m_combo_name.DeleteString(nIndex);
		if (m_combo_name.GetCount() <= nIndex) {
			--nIndex;
		}
		m_LastSelectNum = m_SelectNum = nIndex;
		m_combo_name.SetCurSel(nIndex);
		LoadItem();
		
		return 0;
	}

	LRESULT OnBrowse(UINT uNotifyCode, int nID, CWindow wndCtl)
	{
		CString *strPath;
		switch (nID) {
			case IDC_BUTTON_SPLIT:		strPath = &m_TsSplitter;	break;
			case IDC_BUTTON_GL:			strPath = &m_make_gl;		break;
			case IDC_BUTTON_AAC:		strPath = &m_ts2aac;		break;
			case IDC_BUTTON_AACTOOL:	strPath = &m_aactool;		break;
			case IDC_BUTTON_FAW:		strPath = &m_FAW;			break;
			case IDC_BUTTON_CAP2ASS:	strPath = &m_CAP2ASS;		break;
			default:	return 0;
		}
		DoDataExchange(DDX_SAVE);
		CFileDialog dlg(TRUE, NULL, *strPath);
		if (dlg.DoModal() == IDOK) {
			ATLTRACE(_T("%s\n"), dlg.m_szFileName);
			*strPath = dlg.m_szFileName;
			DoDataExchange(DDX_LOAD);
		}
		return 0;
	}

	void OnComboSelChange(UINT uNotifyCode, int nID, CWindow wndCtl)
	{
		int nIndex = m_combo_name.GetCurSel();
		if (nIndex == CB_ERR) {
			return;
		}
		SaveItem();
		m_SelectNum = nIndex;
		if (nIndex != 0) {
			m_LastSelectNum = nIndex;
		}
		EnableControls();
		LoadItem();
	}

	void EnableControls()
	{
		UINT uCommonIDs[] = {
			IDC_EDIT_SPLIT, IDC_BUTTON_SPLIT,
			IDC_EDIT_GL, IDC_BUTTON_GL,
			IDC_EDIT_AAC, IDC_BUTTON_AAC,
		//	IDC_EDIT_AACTOOL, IDC_BUTTON_AACTOOL,
			IDC_EDIT_FAW, IDC_BUTTON_FAW,
			IDC_EDIT_CAP2ASS, IDC_BUTTON_CAP2ASS,
		};
		for (int i = 0; i < _countof(uCommonIDs); i++) {
			GetDlgItem(uCommonIDs[i]).EnableWindow(m_SelectNum == 0);
		}
		UINT uIDs[] = {
			IDC_SETTING_ADD, IDC_SETTING_DEL,
			IDC_EDIT_BATCH, IDC_EDIT_OPTIONS,
			IDC_CHECK_SPLIT, IDC_EDIT_SPLIT_OPT,
			IDC_CHECK_GL, /*IDC_EDIT_GL_OPT,*/
			IDC_CHECK_AAC, IDC_EDIT_AAC_OPT,
		//	IDC_CHECK_AACTOOL, IDC_EDIT_AACTOOL_OPT,
			IDC_CHECK_FAW, /*IDC_EDIT_FAW_OPT,*/
			IDC_CHECK_CAP2ASS, IDC_EDIT_CAP2ASS_OPT,
		};
		for (int i = 0; i < _countof(uIDs); i++) {
			GetDlgItem(uIDs[i]).EnableWindow(m_SelectNum != 0);
		}
	}

	void LoadItem()
	{
		if (m_SelectNum == 0) {
			m_batch = _T("");
			m_options = _T("");

			m_TsSplitter_opt = _T("");
		//	m_make_gl_opt = _T("");
			m_ts2aac_opt = _T("");
			m_aactool_opt = _T("");
		//	m_FAW_opt = _T("");
			m_CAP2ASS_opt = _T("");

			m_check_split.SetCheck(0);
			m_check_gl.SetCheck(0);
			m_check_aac.SetCheck(0);
			m_check_aactool.SetCheck(0);
			m_check_faw.SetCheck(0);
			m_check_cap2ass.SetCheck(0);
		} else {
			CSettingItem& item = m_SettingList[m_SelectNum - 1];

			m_batch = item.m_BatchFile;
			m_options = item.m_options;

			m_TsSplitter_opt = item.m_TsSplitter_opt;
		//	m_make_gl_opt = item.m_make_gl_opt;
			m_ts2aac_opt = item.m_ts2aac_opt;
			m_aactool_opt = item.m_aactool_opt;
		//	m_FAW_opt = item.m_FAW_opt;
			m_CAP2ASS_opt = item.m_CAP2ASS_opt;

			m_check_split.SetCheck(item.m_Use_TsSplitter);
			m_check_gl.SetCheck(item.m_Use_make_gl);
			m_check_aac.SetCheck(item.m_Use_ts2aac);
			m_check_aactool.SetCheck(item.m_Use_aactool);
			m_check_faw.SetCheck(item.m_Use_FAW);
			m_check_cap2ass.SetCheck(item.m_Use_CAP2ASS);
		}
		DoDataExchange(DDX_LOAD);
	}

	void SaveItem()
	{
		if (m_SelectNum == 0) {
			//
		} else {
			CSettingItem& item = m_SettingList[m_SelectNum - 1];
			GetItem(item);
		}
	}

	void GetItem(CSettingItem& item)
	{
		DoDataExchange(DDX_SAVE);

		TCHAR buf[MAX_PATH];
		m_combo_name.GetWindowText(buf, _countof(buf));
		item.m_SettingName = buf;

		item.m_BatchFile = m_batch;
		item.m_options = m_options;

		item.m_TsSplitter_opt = m_TsSplitter_opt;
	//	item.m_make_gl_opt = m_make_gl_opt;
		item.m_ts2aac_opt = m_ts2aac_opt;
		item.m_aactool_opt = m_aactool_opt;
	//	item.m_FAW_opt = m_FAW_opt;
		item.m_CAP2ASS_opt = m_CAP2ASS_opt;

		item.m_Use_TsSplitter = m_check_split.GetCheck();
		item.m_Use_make_gl = m_check_gl.GetCheck();
		item.m_Use_ts2aac = m_check_aac.GetCheck();
		item.m_Use_aactool = m_check_aactool.GetCheck();
		item.m_Use_FAW = m_check_faw.GetCheck();
		item.m_Use_CAP2ASS = m_check_cap2ass.GetCheck();
	}
};
