/*
 *	fprnhook.dll Ver.0.07	Copyright (C) 2009-2011  kt
 *
 *	msvcrt.dll  fprintf() tbNAfprintf() ̂т fflush() sB
 */

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <stdarg.h>
#include <tchar.h>

#if _MSC_VER != 1200
#error Please use Visual C++ 6.0. (msvcrt.dll is needed.)
#endif

int __cdecl hook_fprintf(FILE *stream, const char *format, ...);
int __cdecl hook_printf(const char *format, ...);
BOOL SetHook_fprintf(void);
BOOL SetHook_printf(void);
BOOL SetApiHook(HMODULE hMod, LPCSTR szDllName, FARPROC pfnCurrent, FARPROC pfnNew);


BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
	switch (fdwReason) {
	case DLL_PROCESS_ATTACH:
		SetHook_fprintf();		// ts2aac
		SetHook_printf();		// fawcl
		break;
	case DLL_PROCESS_DETACH:
		break;
	case DLL_THREAD_ATTACH:
		break;
	case DLL_THREAD_DETACH:
		break;
	}
	return TRUE;
}


int __cdecl hook_fprintf(FILE *stream, const char *format, ...)
{
	int ret;
	va_list arglist;
	
//OutputDebugString(_T("hook_fprintf()\n"));
	va_start(arglist, format);
	ret = vfprintf(stream, format, arglist);
	va_end(arglist);
	
	if (stream == stderr) {
//OutputDebugString(_T("stream == stderr\n"));
//fprintf(stream, " !hooked!\n");
		fflush(stream);
	}
	return ret;
}

int __cdecl hook_printf(const char *format, ...)
{
	int ret;
	va_list arglist;
	
//OutputDebugString(_T("hook_printf()\n"));
	va_start(arglist, format);
	ret = vprintf(format, arglist);
	va_end(arglist);
	
	fflush(stdout);
	return ret;
}

BOOL SetHook_fprintf(void)
{
	LPCSTR szDllName = "msvcrt.dll";
	HMODULE hDll = GetModuleHandleA(szDllName);
	if (hDll == NULL) {
		return FALSE;
	}
	FARPROC pfnCurrent = GetProcAddress(hDll, "fprintf");
	if (pfnCurrent == NULL) {
		return FALSE;
	}
	return SetApiHook(GetModuleHandle(NULL), szDllName,
			pfnCurrent, (FARPROC) hook_fprintf);
}

BOOL SetHook_printf(void)
{
	LPCSTR szDllName = "msvcrt.dll";
	HMODULE hDll = GetModuleHandleA(szDllName);
	if (hDll == NULL) {
		return FALSE;
	}
	FARPROC pfnCurrent = GetProcAddress(hDll, "printf");
	if (pfnCurrent == NULL) {
		return FALSE;
	}
	return SetApiHook(GetModuleHandle(NULL), szDllName,
			pfnCurrent, (FARPROC) hook_printf);
}

BOOL SetApiHook(HMODULE hMod, LPCSTR szDllName, FARPROC pfnCurrent, FARPROC pfnNew)
{
	DWORD dwBase = (DWORD) hMod;
	PIMAGE_DOS_HEADER dos_hdr = (PIMAGE_DOS_HEADER) dwBase;
	PIMAGE_NT_HEADERS nt_hdr = (PIMAGE_NT_HEADERS) (dwBase + dos_hdr->e_lfanew);
	if ((nt_hdr->Signature != IMAGE_NT_SIGNATURE)
			|| !(nt_hdr->FileHeader.Characteristics & IMAGE_FILE_32BIT_MACHINE)) {
		return FALSE;
	}
	PIMAGE_IMPORT_DESCRIPTOR pImpDesc = (PIMAGE_IMPORT_DESCRIPTOR)
			(dwBase + nt_hdr->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress);
	while (pImpDesc->Name != 0) {
		LPCSTR name = (LPCSTR) (dwBase + pImpDesc->Name);
		if (_strcmpi(name, szDllName) == 0) {
			// DLL found
			break;
		}
		pImpDesc++;
	}
	if (pImpDesc->Name == 0) {
		// DLL not found
		return FALSE;
	}
	PIMAGE_THUNK_DATA pThunk = (PIMAGE_THUNK_DATA) (dwBase + pImpDesc->FirstThunk);
	while (pThunk->u1.Function) {
		FARPROC *ppfn = (FARPROC *) &pThunk->u1.Function;
		if (*ppfn == pfnCurrent) {
			// Function found
			HANDLE hCurrent = GetCurrentProcess();
			if (!WriteProcessMemory(hCurrent, ppfn, &pfnNew, sizeof(pfnNew), NULL)
					&& (GetLastError() == ERROR_NOACCESS)) {
				DWORD dwOld;
				if (VirtualProtect(ppfn, sizeof(ppfn), PAGE_WRITECOPY, &dwOld)) {
					WriteProcessMemory(hCurrent, ppfn, &pfnNew, sizeof(pfnNew), NULL);
					VirtualProtect(ppfn, sizeof(ppfn), dwOld, &dwOld);
				}
			}
			return TRUE;
		}
		pThunk++;
	}
	return FALSE;
}
